Graphics3D 800,600,32,2
SetBuffer BackBuffer()

Include "Lighting.bb"

Global Cam=CreateCamera()
Global P=CreatePivot()
Global Lit=CreateLight()
Global S1=CreateSphere(),S2=CreateSphere(),TexYP#
Global Cub=CreateCube(P):ScaleEntity Cub,10,10,1:MoveEntity Cub,0,0,10

MoveEntity S1,5,0,0
MoveEntity S2,-5,0,0
PositionEntity S1,5+Rnd(5,15),Rnd(-5,5),Rnd(-5,5)
PositionEntity S2,-5+Rnd(-15,-5),Rnd(-5,5),Rnd(-5,5)

MoveEntity Cam,0,0,-20
EntityParent Cam,P

X1#=EntityX#(S1,1)
Y1#=EntityY#(S1,1)
Z1#=EntityZ#(S1,1)
X2#=EntityX#(S2,1)
Y2#=EntityY#(S2,1)
Z2#=EntityZ#(S2,1)
Global L=CreateObjectLightingDS%(S1,S2,Cam,2,50,10,1.5)
Global Tex=LoadTexture("LTex.jpg",1+2+8):LightingTextureDS( L,Tex,0,0.03,0,0 )
LightingAutosizeDS(L,True,3,7)

Repeat

If KeyDown(200) Then TurnEntity P,-3,0,0
If KeyDown(208) Then TurnEntity P,3,0,0
If KeyDown(203) Then TurnEntity P,0,3,0
If KeyDown(205) Then TurnEntity P,0,-3,0
If KeyHit(57)
PositionEntity S1,5+Rnd(5,15),Rnd(-5,5),Rnd(-5,5)
PositionEntity S2,-5+Rnd(-15,-5),Rnd(-5,5),Rnd(-5,5)
EndIf

UpdateLightingDS()

RenderWorld
vFPS=MilliSecs()
If vFPS-vLastFPS>1000
 vShowFPS=vCurFPS
 vLastFPS=vFPS
 vCurFPS=0
Else
 vCurFPS=vCurFPS+1
End If
Text 10,40,"FPS: "+vShowFPS+"   "+(-ATan2(EntityZ#(Cam,1),EntityY#(Cam,1)))
Flip

Until KeyHit(1)
End