Graphics3D 800,600,32,2
SetBuffer BackBuffer()

Include "Lighting.bb"

SeedRnd MilliSecs()

Global camera=CreateCamera()
Global Tex=LoadTexture("LTex.jpg",1+2+8)
PositionEntity camera,0,50,-180
RotateEntity camera,30,0,0
CameraClsColor camera,5,20,30

SetFont (LoadFont ("Arial",20))

WorldLight=CreateLight()
RotateEntity WorldLight,20,40,0

For i=1 To 20
 For j=1 To 20
  t=CreateCube()
	PositionEntity t,i*10-100,-30,j*10-100
	ScaleEntity t,3,1,3
 Next
Next

;-------------------------------------------------------------------------;
;--- Static --------------------------------------------------------------;
;-------------------------------------------------------------------------;

SCX#=-50
SCY#=20
SCZ#=60

StaticCenter=CreateSphere()
ScaleEntity StaticCenter,2,2,2
PositionEntity StaticCenter,SCX,SCY,SCZ
EntityColor StaticCenter,10,250,20

Dim StaticObject(10)
Dim StaticSpeed#(10,2)

StaticMax=3
StaticPos=50
StaticAcc#=0.05
For i=0 To StaticMax
 StaticObject(i)=CreateSphere()
 PositionEntity StaticObject(i),SCX+Rnd(-Staticpos,Staticpos),SCY+Rnd(-Staticpos,Staticpos),SCZ+Rnd(-Staticpos,Staticpos)
 ScaleEntity StaticObject(i),1.5,1.5,1.5
 EntityColor StaticObject(i),Rand(50,255),Rand(50,255),Rand(50,255)
Next

For i=0 To StaticMax
 For j=i To StaticMax
  LengthSegment%=Rand(15,20)
	Radius#=0.15
	Radius1#=1
	BeginPivot%=StaticObject(i)
	EndPivot%=StaticObject(j)
	ChangeTime%=Rnd(3,10)
	RandomizeRange#=Rnd(2,3)
	LType=LStatic
  If i<>j 
	 temp=CreateObjectLightingDS%(BeginPivot,EndPivot,Camera,3.5,50,10,1.5)
	 ;EntityColor temp,Rand(200,255),Rand(200,255),Rand(200,255)
	 LightingTextureDS( temp,Tex,0,0.03,0,0 ):LightingAutosizeDS(temp,True,3,7)
	EndIf
 Next
Next



;-------------------------------------------------------------------------;
;--- Dynamic -------------------------------------------------------------;
;-------------------------------------------------------------------------;


DCX#=80
DCY#=50
DCZ#=-30

DynamicCenter=CreateSphere()
ScaleEntity DynamicCenter,2,2,2
PositionEntity DynamicCenter,DCX,DCY,DCZ
EntityColor DynamicCenter,10,250,20

Dim DynamicObject(10)
Dim DynamicSpeed#(10,2)

DynamicMax=3
DynamicPos=40
DynamicAcc#=0.01
For i=0 To DynamicMax
 DynamicObject(i)=CreateSphere()
 PositionEntity DynamicObject(i),DCX+Rnd(-Dynamicpos,Dynamicpos),DCY+Rnd(-Dynamicpos,Dynamicpos),DCZ+Rnd(-Dynamicpos,Dynamicpos)
 ScaleEntity DynamicObject(i),1.5,1.5,1.5
 EntityColor DynamicObject(i),Rand(50,255),Rand(50,255),Rand(50,255)
Next

For i=0 To DynamicMax
 For j=i To DynamicMax
  LengthSegment%=Rand(15,20)
	Radius#=0.15
	Radius1#=1
	BeginPivot%=DynamicObject(i)
	EndPivot%=DynamicObject(j)
	ChangeTime%=Rnd(3,10)
	RandomizeRange#=Rnd(2,3)
	LType=LDynamic
  If i<>j Then 
	 temp=CreateObjectLightingDS%(BeginPivot,EndPivot,Camera,3.5,50,10,1.5)
	 ;EntityColor temp,Rand(200,255),Rand(200,255),Rand(200,255)
	 LightingTextureDS( temp,Tex,0,0.03,0,0 ):LightingAutosizeDS(temp,True,5,10)
  EndIf
 Next
Next

;-------------------------------------------------------------------------;
;--- Shot ----------------------------------------------------------------;
;-------------------------------------------------------------------------;


WCX#=-80
WCY#=10
WCZ#=-60

ShotCenter=CreateSphere()
ScaleEntity ShotCenter,2,2,2
PositionEntity ShotCenter,WCX,WCY,WCZ
EntityColor ShotCenter,10,250,20

Dim ShotObject(10)
Dim ShotSpeed#(10,2)

ShotMax=3
ShotPos=40
ShotAcc#=0.01

For i=0 To ShotMax
 ShotObject(i)=CreateSphere()
 PositionEntity ShotObject(i),WCX+Rnd(-Shotpos,Shotpos),WCY+Rnd(-Shotpos,Shotpos),WCZ+Rnd(-Shotpos,Shotpos)
 ScaleEntity ShotObject(i),1.5,1.5,1.5
 EntityColor ShotObject(i),Rand(50,255),Rand(50,255),Rand(50,255)
Next


LengthSegment%=Rand(15,20)
Radius#=0.15
Radius1#=1
BeginPivot%=ShotObject(0)
EndPivot%=ShotObject(1)
ChangeTime%=Rnd(3,10)
RandomizeRange#=Rnd(2,3)
LType=LShot
ssss=CreateObjectLightingDS%(BeginPivot,EndPivot,Camera,3.5,50,10,1.5)
LightingTextureDS( ssss,Tex,0,0.03,0,0 ):LightingAutosizeDS(temp,True,3,7)



Repeat


 gradx=gradx+MouseXSpeed()*0.1
 grady=grady+MouseYSpeed()*0.1
 RotateEntity camera,grady,-gradx,0,False
 MoveEntity camera,KeyDown(205)-KeyDown(203),0,KeyDown(200)-KeyDown(208)+MouseDown(1)-MouseDown(2)
 MoveMouse GraphicsWidth()*0.5,GraphicsHeight()*0.5
 
 
 For i=0 To StaticMax
  If EntityX(StaticObject(i))<SCX Then StaticSpeed(i,0)=StaticSpeed(i,0)+Rnd(StaticAcc)
  If EntityX(StaticObject(i))>SCX Then StaticSpeed(i,0)=StaticSpeed(i,0)-Rnd(StaticAcc)
  If EntityY(StaticObject(i))<SCY Then StaticSpeed(i,1)=StaticSpeed(i,1)+Rnd(StaticAcc)
  If EntityY(StaticObject(i))>SCY Then StaticSpeed(i,1)=StaticSpeed(i,1)-Rnd(StaticAcc)
	If EntityZ(StaticObject(i))<SCZ Then StaticSpeed(i,2)=StaticSpeed(i,2)+Rnd(StaticAcc)
  If EntityZ(StaticObject(i))>SCZ Then StaticSpeed(i,2)=StaticSpeed(i,2)-Rnd(StaticAcc)
  TranslateEntity StaticObject(i),StaticSpeed(i,0),StaticSpeed(i,1),StaticSpeed(i,2)
 Next
 
 For i=0 To DynamicMax
  If EntityX(DynamicObject(i))<DCX Then DynamicSpeed(i,0)=DynamicSpeed(i,0)+Rnd(DynamicAcc)
  If EntityX(DynamicObject(i))>DCX Then DynamicSpeed(i,0)=DynamicSpeed(i,0)-Rnd(DynamicAcc)
  If EntityY(DynamicObject(i))<DCY Then DynamicSpeed(i,1)=DynamicSpeed(i,1)+Rnd(DynamicAcc)
  If EntityY(DynamicObject(i))>DCY Then DynamicSpeed(i,1)=DynamicSpeed(i,1)-Rnd(DynamicAcc)
	If EntityZ(DynamicObject(i))<DCZ Then DynamicSpeed(i,2)=DynamicSpeed(i,2)+Rnd(DynamicAcc)
  If EntityZ(DynamicObject(i))>DCZ Then DynamicSpeed(i,2)=DynamicSpeed(i,2)-Rnd(DynamicAcc)
  TranslateEntity DynamicObject(i),DynamicSpeed(i,0),DynamicSpeed(i,1),DynamicSpeed(i,2)
 Next
 
 For i=0 To ShotMax
  If EntityX(ShotObject(i))<WCX Then ShotSpeed(i,0)=ShotSpeed(i,0)+Rnd(ShotAcc)
  If EntityX(ShotObject(i))>WCX Then ShotSpeed(i,0)=ShotSpeed(i,0)-Rnd(ShotAcc)
  If EntityY(ShotObject(i))<WCY Then ShotSpeed(i,1)=ShotSpeed(i,1)+Rnd(ShotAcc)
  If EntityY(ShotObject(i))>WCY Then ShotSpeed(i,1)=ShotSpeed(i,1)-Rnd(ShotAcc)
	If EntityZ(ShotObject(i))<WCZ Then ShotSpeed(i,2)=ShotSpeed(i,2)+Rnd(ShotAcc)
  If EntityZ(ShotObject(i))>WCZ Then ShotSpeed(i,2)=ShotSpeed(i,2)-Rnd(ShotAcc)
  TranslateEntity ShotObject(i),ShotSpeed(i,0),ShotSpeed(i,1),ShotSpeed(i,2)
 Next
 
 ltime=ltime-1
 If LTime<=0
  
  SO=Rand(0,ShotMax)
	ChangeTime%=Rnd(3,8)
	Time%=Rnd(3,10)
  ;EntityColor ssss,Rand(200,255),Rand(200,255),Rand(200,255)
  ;LightningShot(SSSS,ChangeTime%,Time%,ShotCenter,ShotObject(SO))
	ltime=Rand(15,100)
 EndIf
 
 
 UpdateLightingDS()
 
 RenderWorld

 CameraProject(camera,EntityX(StaticCenter),EntityY(StaticCenter),EntityZ(StaticCenter)) 
 If EntityInView(StaticCenter,camera)=True
  Text ProjectedX#(),ProjectedY#(),"Static"
 EndIf
 CameraProject(camera,EntityX(DynamicCenter),EntityY(DynamicCenter),EntityZ(DynamicCenter)) 
 If EntityInView(DynamicCenter,camera)=True
  Text ProjectedX#(),ProjectedY#(),"Dynamic"
 EndIf
 CameraProject(camera,EntityX(ShotCenter),EntityY(ShotCenter),EntityZ(ShotCenter)) 
 If EntityInView(ShotCenter,camera)=True
  Text ProjectedX#(),ProjectedY#(),"Shot"
 EndIf
 
vFPS=MilliSecs()
If vFPS-vLastFPS>1000
 vShowFPS=vCurFPS
 vLastFPS=vFPS
 vCurFPS=0
Else
 vCurFPS=vCurFPS+1
End If
Text 10,40,"FPS: "+vShowFPS

 Flip
 
Until KeyHit(1)

End